Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComDataCU.h	(revision 1200)
@@ -574,10 +583,11 @@
   // member functions for motion vector
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   Void          getMvField            ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefPicList, TComMvField& rcMvField );
-  
+
   Void          fillMvpCand           ( UInt uiPartIdx, UInt uiPartAddr, RefPicList eRefPicList, Int iRefIdx, AMVPInfo* pInfo );
   Bool          isDiffMER             ( Int xN, Int yN, Int xP, Int yP);
   Void          getPartPosition       ( UInt partIdx, Int& xP, Int& yP, Int& nPSW, Int& nPSH);
+
   Void          setMVPIdx             ( RefPicList eRefPicList, UInt uiIdx, Int iMVPIdx)  { m_apiMVPIdx[eRefPicList][uiIdx] = iMVPIdx;  }
   Int           getMVPIdx             ( RefPicList eRefPicList, UInt uiIdx)               { return m_apiMVPIdx[eRefPicList][uiIdx];     }
@@ -587,10 +597,10 @@
   Int           getMVPNum             ( RefPicList eRefPicList, UInt uiIdx )              { return m_apiMVPNum[eRefPicList][uiIdx];     }
   Char*         getMVPNum             ( RefPicList eRefPicList )                          { return m_apiMVPNum[eRefPicList];            }
-  
+
   Void          setMVPIdxSubParts     ( Int iMVPIdx, RefPicList eRefPicList, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
   Void          setMVPNumSubParts     ( Int iMVPNum, RefPicList eRefPicList, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
-  
+
   Void          clipMv                ( TComMv&     rcMv     );
-#if H_MV
+#if NH_MV
   Void          checkMvVertRest (TComMv&  rcMv,  RefPicList eRefPicList, int iRefIdx );
 #endif
@@ -598,5 +608,5 @@
   Void          getMvPredAbove        ( TComMv&     rcMvPred )   { rcMvPred = m_cMvFieldB.getMv(); }
   Void          getMvPredAboveRight   ( TComMv&     rcMvPred )   { rcMvPred = m_cMvFieldC.getMv(); }
-#if H_3D
+#if NH_3D
   Void          compressMV            ( Int scale );
 #else            
@@ -606,38 +616,40 @@
   // utility functions for neighbouring information
   // -------------------------------------------------------------------------------------------------------------------
-  
-  TComDataCU*   getCULeft                   () { return m_pcCULeft;       }
-  TComDataCU*   getCUAbove                  () { return m_pcCUAbove;      }
-  TComDataCU*   getCUAboveLeft              () { return m_pcCUAboveLeft;  }
-  TComDataCU*   getCUAboveRight             () { return m_pcCUAboveRight; }
+
+  TComDataCU*   getCtuLeft                  () { return m_pCtuLeft;       }
+  TComDataCU*   getCtuAbove                 () { return m_pCtuAbove;      }
+  TComDataCU*   getCtuAboveLeft             () { return m_pCtuAboveLeft;  }
+  TComDataCU*   getCtuAboveRight            () { return m_pCtuAboveRight; }
   TComDataCU*   getCUColocated              ( RefPicList eRefPicList ) { return m_apcCUColocated[eRefPicList]; }
-
-
-  TComDataCU*   getPULeft                   ( UInt&  uiLPartUnitIdx, 
-                                              UInt uiCurrPartUnitIdx, 
-                                              Bool bEnforceSliceRestriction=true, 
+  Bool          CUIsFromSameSlice           ( const TComDataCU *pCU /* Can be NULL */) const { return ( pCU!=NULL && pCU->getSlice()->getSliceCurStartCtuTsAddr() == getSlice()->getSliceCurStartCtuTsAddr() ); }
+  Bool          CUIsFromSameTile            ( const TComDataCU *pCU /* Can be NULL */) const;
+  Bool          CUIsFromSameSliceAndTile    ( const TComDataCU *pCU /* Can be NULL */) const;
+  Bool          CUIsFromSameSliceTileAndWavefrontRow( const TComDataCU *pCU /* Can be NULL */) const;
+  Bool          isLastSubCUOfCtu(const UInt absPartIdx);
+
+
+  TComDataCU*   getPULeft                   ( UInt&  uiLPartUnitIdx,
+                                              UInt uiCurrPartUnitIdx,
+                                              Bool bEnforceSliceRestriction=true,
                                               Bool bEnforceTileRestriction=true );
   TComDataCU*   getPUAbove                  ( UInt&  uiAPartUnitIdx,
-                                              UInt uiCurrPartUnitIdx, 
-                                              Bool bEnforceSliceRestriction=true, 
-                                              Bool planarAtLCUBoundary = false,
+                                              UInt uiCurrPartUnitIdx,
+                                              Bool bEnforceSliceRestriction=true,
+                                              Bool planarAtCTUBoundary = false,
                                               Bool bEnforceTileRestriction=true );
   TComDataCU*   getPUAboveLeft              ( UInt&  uiALPartUnitIdx, UInt uiCurrPartUnitIdx, Bool bEnforceSliceRestriction=true );
-  TComDataCU*   getPUAboveRight             ( UInt&  uiARPartUnitIdx, UInt uiCurrPartUnitIdx, Bool bEnforceSliceRestriction=true );
-  TComDataCU*   getPUBelowLeft              ( UInt&  uiBLPartUnitIdx, UInt uiCurrPartUnitIdx, Bool bEnforceSliceRestriction=true );
-
-  TComDataCU*   getQpMinCuLeft              ( UInt&  uiLPartUnitIdx , UInt uiCurrAbsIdxInLCU );
-  TComDataCU*   getQpMinCuAbove             ( UInt&  aPartUnitIdx , UInt currAbsIdxInLCU );
-  Char          getRefQP                    ( UInt   uiCurrAbsIdxInLCU                       );
-
-  TComDataCU*   getPUAboveRightAdi          ( UInt&  uiARPartUnitIdx, UInt uiCurrPartUnitIdx, UInt uiPartUnitOffset = 1, Bool bEnforceSliceRestriction=true );
-  TComDataCU*   getPUBelowLeftAdi           ( UInt&  uiBLPartUnitIdx, UInt uiCurrPartUnitIdx, UInt uiPartUnitOffset = 1, Bool bEnforceSliceRestriction=true );
-  
+
+  TComDataCU*   getQpMinCuLeft              ( UInt&  uiLPartUnitIdx , UInt uiCurrAbsIdxInCtu );
+  TComDataCU*   getQpMinCuAbove             ( UInt&  uiAPartUnitIdx , UInt uiCurrAbsIdxInCtu );
+  Char          getRefQP                    ( UInt   uiCurrAbsIdxInCtu                       );
+
+  /// returns CU and part index of the PU above the top row of the current uiCurrPartUnitIdx of the CU, at a horizontal offset (to the right) of uiPartUnitOffset (in parts)
+  TComDataCU*   getPUAboveRight             ( UInt&  uiARPartUnitIdx, UInt uiCurrPartUnitIdx, UInt uiPartUnitOffset = 1, Bool bEnforceSliceRestriction=true );
+  /// returns CU and part index of the PU left of the lefthand column of the current uiCurrPartUnitIdx of the CU, at a vertical offset (below) of uiPartUnitOffset (in parts)
+  TComDataCU*   getPUBelowLeft              ( UInt&  uiBLPartUnitIdx, UInt uiCurrPartUnitIdx, UInt uiPartUnitOffset = 1, Bool bEnforceSliceRestriction=true );
+
   Void          deriveLeftRightTopIdx       ( UInt uiPartIdx, UInt& ruiPartIdxLT, UInt& ruiPartIdxRT );
   Void          deriveLeftBottomIdx         ( UInt uiPartIdx, UInt& ruiPartIdxLB );
-  
-  Void          deriveLeftRightTopIdxAdi    ( UInt& ruiPartIdxLT, UInt& ruiPartIdxRT, UInt uiPartOffset, UInt uiPartDepth );
-  Void          deriveLeftBottomIdxAdi      ( UInt& ruiPartIdxLB, UInt  uiPartOffset, UInt uiPartDepth );
-  
+
   Bool          hasEqualMotion              ( UInt uiAbsPartIdx, TComDataCU* pcCandCU, UInt uiCandAbsPartIdx );
 
@@ -661,11 +673,9 @@
   Void          xGetInterMergeCandidates ( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours
 #else
-  Void          getInterMergeCandidates ( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours
+  Void          getInterMergeCandidates       ( UInt uiAbsPartIdx, UInt uiPUIdx, TComMvField* pcMFieldNeighbours, UChar* puhInterDirNeighbours, Int& numValidMergeCand, Int mrgCandIdx = -1 );
 #endif
 #if H_3D_SPIVMP
                                             , TComMvField* pcMvFieldSP, UChar* puhInterDirSP
 #endif
-                                            , Int& numValidMergeCand, Int mrgCandIdx = -1
-                                            );
 
 #if H_3D_VSP
@@ -685,12 +695,12 @@
   Void          deriveLeftRightTopIdxGeneral  ( UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLT, UInt& ruiPartIdxRT );
   Void          deriveLeftBottomIdxGeneral    ( UInt uiAbsPartIdx, UInt uiPartIdx, UInt& ruiPartIdxLB );
-  
-  
+
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for modes
   // -------------------------------------------------------------------------------------------------------------------
-  
-  Bool          isIntra   ( UInt uiPartIdx )  { return m_pePredMode[ uiPartIdx ] == MODE_INTRA; }
-  Bool          isSkipped ( UInt uiPartIdx );                                                     ///< SKIP (no residual)
+
+  Bool          isIntra            ( UInt uiPartIdx )  const { return m_pePredMode[ uiPartIdx ] == MODE_INTRA;                                              }
+  Bool          isInter            ( UInt uiPartIdx )  const { return m_pePredMode[ uiPartIdx ] == MODE_INTER;                                              }
+  Bool          isSkipped          ( UInt uiPartIdx );                                                     ///< returns true, if the partiton is skipped
   Bool          isBipredRestriction( UInt puIdx );
 
@@ -702,41 +712,38 @@
   // member functions for symbol prediction (most probable / mode conversion)
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   UInt          getIntraSizeIdx                 ( UInt uiAbsPartIdx                                       );
-  
+
   Void          getAllowedChromaDir             ( UInt uiAbsPartIdx, UInt* uiModeList );
-  Int           getIntraDirLumaPredictor        ( UInt uiAbsPartIdx, Int* uiIntraDirPred, Int* piMode = NULL );
-  
+  Void          getIntraDirPredictor            ( UInt uiAbsPartIdx, Int uiIntraDirPred[NUM_MOST_PROBABLE_MODES], const ComponentID compID, Int* piMode = NULL );
+
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for SBAC context
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   UInt          getCtxSplitFlag                 ( UInt   uiAbsPartIdx, UInt uiDepth                   );
-  UInt          getCtxQtCbf                     ( TextType eType, UInt uiTrDepth );
+  UInt          getCtxQtCbf                     ( TComTU &rTu, const ChannelType chType );
 
   UInt          getCtxSkipFlag                  ( UInt   uiAbsPartIdx                                 );
   UInt          getCtxInterDir                  ( UInt   uiAbsPartIdx                                 );
-  
 #if H_3D_ARP
   UInt          getCTXARPWFlag                  ( UInt   uiAbsPartIdx                                 );
 #endif  
-  UInt          getSliceStartCU         ( UInt pos )                  { return m_sliceStartCU[pos-m_uiAbsIdxInLCU];                                                                                          }
-  UInt          getSliceSegmentStartCU  ( UInt pos )                  { return m_sliceSegmentStartCU[pos-m_uiAbsIdxInLCU];                                                                                   }
-  UInt&         getTotalBins            ()                            { return m_uiTotalBins;                                                                                                  }
+
+  UInt&         getTotalBins            ()                            { return m_uiTotalBins;                              }
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for RD cost storage
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   Double&       getTotalCost()                  { return m_dTotalCost;        }
-#if H_3D_VSO
+#if NH_3D_VSO
   Dist&         getTotalDistortion()            { return m_uiTotalDistortion; }
 #else
-  UInt&         getTotalDistortion()            { return m_uiTotalDistortion; }
+  Distortion&   getTotalDistortion()            { return m_uiTotalDistortion; }
 #endif
   UInt&         getTotalBits()                  { return m_uiTotalBits;       }
   UInt&         getTotalNumPart()               { return m_uiNumPartition;    }
 
-  UInt          getCoefScanIdx(UInt uiAbsPartIdx, UInt uiWidth, Bool bIsLuma, Bool bIsIntra);
-
+  UInt          getCoefScanIdx(const UInt uiAbsPartIdx, const UInt uiWidth, const UInt uiHeight, const ComponentID compID) const ;
 
 #if H_3D_DIM
@@ -760,5 +767,5 @@
     return (( addrA ^ addrB ) &  ( numUnitsPerRow - 1 ) ) == 0;
   }
-  
+
   /** Check whether 2 addresses point to the same row
    * \param addrA          First address in raster scan order
@@ -772,5 +779,5 @@
     return (( addrA ^ addrB ) &~ ( numUnitsPerRow - 1 ) ) == 0;
   }
-  
+
   /** Check whether 2 addresses point to the same row or column
    * \param addrA          First address in raster scan order
@@ -783,5 +790,5 @@
     return isEqualCol( addrA, addrB, numUnitsPerRow ) | isEqualRow( addrA, addrB, numUnitsPerRow );
   }
-  
+
   /** Check whether one address points to the first column
    * \param addr           Address in raster scan order
@@ -794,5 +801,5 @@
     return ( addr & ( numUnitsPerRow - 1 ) ) == 0;
   }
-  
+
   /** Check whether one address points to the first row
    * \param addr           Address in raster scan order
@@ -805,5 +812,5 @@
     return ( addr &~ ( numUnitsPerRow - 1 ) ) == 0;
   }
-  
+
   /** Check whether one address points to a column whose index is smaller than a given value
    * \param addr           Address in raster scan order
@@ -817,5 +824,5 @@
     return ( addr & ( numUnitsPerRow - 1 ) ) < val;
   }
-  
+
   /** Check whether one address points to a row whose index is smaller than a given value
    * \param addr           Address in raster scan order
@@ -829,5 +836,5 @@
     return addr < val * numUnitsPerRow;
   }
-};
+}
 
 //! \}
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
- *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * granted under this license.
+ *
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -45,4 +45,6 @@
 #include <assert.h>
 
+#include "TComChromaFormat.h"
+
 
 //! \ingroup TLibCommon
@@ -53,5 +55,5 @@
 // ====================================================================================================================
 
-const Short TComInterpolationFilter::m_lumaFilter[4][NTAPS_LUMA] =
+const TFilterCoeff TComInterpolationFilter::m_lumaFilter[LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_LUMA] =
 {
   {  0, 0,   0, 64,  0,   0, 0,  0 },
@@ -61,5 +63,5 @@
 };
 
-const Short TComInterpolationFilter::m_chromaFilter[8][NTAPS_CHROMA] =
+const TFilterCoeff TComInterpolationFilter::m_chromaFilter[CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_CHROMA] =
 {
   {  0, 64,  0,  0 },
@@ -111,8 +113,8 @@
  * \param isLast     Flag indicating whether it is the last filtering operation
  */
-Void TComInterpolationFilter::filterCopy(Int bitDepth, const Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast)
+Void TComInterpolationFilter::filterCopy(Int bitDepth, const Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast)
 {
   Int row, col;
-  
+
   if ( isFirst == isLast )
   {
@@ -123,46 +125,51 @@
         dst[col] = src[col];
       }
-      
+
       src += srcStride;
       dst += dstStride;
-    }              
+    }
   }
   else if ( isFirst )
   {
-    Int shift = IF_INTERNAL_PREC - bitDepth;
-    
+    const Int shift = std::max<Int>(2, (IF_INTERNAL_PREC - bitDepth));
+
     for (row = 0; row < height; row++)
     {
       for (col = 0; col < width; col++)
       {
-        Short val = src[col] << shift;
-        dst[col] = val - (Short)IF_INTERNAL_OFFS;
-      }
-      
+        Pel val = leftShift_round(src[col], shift);
+        dst[col] = val - (Pel)IF_INTERNAL_OFFS;
+      }
+
       src += srcStride;
       dst += dstStride;
-    }          
-  }
-  else
-  {
-    Int shift = IF_INTERNAL_PREC - bitDepth;
-    Short offset = IF_INTERNAL_OFFS;
-    offset += shift?(1 << (shift - 1)):0;
-    Short maxVal = (1 << bitDepth) - 1;
-    Short minVal = 0;
+    }
+  }
+  else
+  {
+    const Int shift = std::max<Int>(2, (IF_INTERNAL_PREC - bitDepth));
+
+    Pel maxVal = (1 << bitDepth) - 1;
+    Pel minVal = 0;
     for (row = 0; row < height; row++)
     {
       for (col = 0; col < width; col++)
       {
-        Short val = src[ col ];
-        val = ( val + offset ) >> shift;
-        if (val < minVal) val = minVal;
-        if (val > maxVal) val = maxVal;
+        Pel val = src[ col ];
+        val = rightShift_round((val + IF_INTERNAL_OFFS), shift);
+        if (val < minVal)
+        {
+          val = minVal;
+        }
+        if (val > maxVal)
+        {
+          val = maxVal;
+        }
         dst[col] = val;
       }
-      
+
       src += srcStride;
       dst += dstStride;
-    }              
+    }
   }
 }
@@ -185,9 +192,9 @@
  */
 template<Int N, Bool isVertical, Bool isFirst, Bool isLast>
-Void TComInterpolationFilter::filter(Int bitDepth, Short const *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Short const *coeff)
+Void TComInterpolationFilter::filter(Int bitDepth, Pel const *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, TFilterCoeff const *coeff)
 {
   Int row, col;
-  
-  Short c[8];
+
+  Pel c[8];
   c[0] = coeff[0];
   c[1] = coeff[1];
@@ -207,12 +214,16 @@
     c[7] = coeff[7];
   }
-  
+
   Int cStride = ( isVertical ) ? srcStride : 1;
   src -= ( N/2 - 1 ) * cStride;
 
   Int offset;
-  Short maxVal;
-  Int headRoom = IF_INTERNAL_PREC - bitDepth;
-  Int shift = IF_FILTER_PREC;
+  Pel maxVal;
+  Int headRoom = std::max<Int>(2, (IF_INTERNAL_PREC - bitDepth));
+  Int shift    = IF_FILTER_PREC;
+  // with the current settings (IF_INTERNAL_PREC = 14 and IF_FILTER_PREC = 6), though headroom can be
+  // negative for bit depths greater than 14, shift will remain non-negative for bit depths of 8->20
+  assert(shift >= 0);
+
   if ( isLast )
   {
@@ -228,5 +239,5 @@
     maxVal = 0;
   }
-  
+
   for (row = 0; row < height; row++)
   {
@@ -234,5 +245,5 @@
     {
       Int sum;
-      
+
       sum  = src[ col + 0 * cStride] * c[0];
       sum += src[ col + 1 * cStride] * c[1];
@@ -250,19 +261,19 @@
       {
         sum += src[ col + 6 * cStride] * c[6];
-        sum += src[ col + 7 * cStride] * c[7];        
-      }
-      
-      Short val = ( sum + offset ) >> shift;
+        sum += src[ col + 7 * cStride] * c[7];
+      }
+
+      Pel val = ( sum + offset ) >> shift;
       if ( isLast )
       {
         val = ( val < 0 ) ? 0 : val;
-        val = ( val > maxVal ) ? maxVal : val;        
+        val = ( val > maxVal ) ? maxVal : val;
       }
       dst[col] = val;
     }
-    
+
     src += srcStride;
     dst += dstStride;
-  }    
+  }
 }
 
@@ -282,5 +293,5 @@
  */
 template<Int N>
-Void TComInterpolationFilter::filterHor(Int bitDepth, Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Bool isLast, Short const *coeff)
+Void TComInterpolationFilter::filterHor(Int bitDepth, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Bool isLast, TFilterCoeff const *coeff)
 {
   if ( isLast )
@@ -298,5 +309,5 @@
  *
  * \tparam N          Number of taps
- * \param  bitDpeth   Sample bit depth
+ * \param  bitDepth   Bit depth
  * \param  src        Pointer to source samples
  * \param  srcStride  Stride of source samples
@@ -310,5 +321,5 @@
  */
 template<Int N>
-Void TComInterpolationFilter::filterVer(Int bitDepth, Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast, Short const *coeff)
+Void TComInterpolationFilter::filterVer(Int bitDepth, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast, TFilterCoeff const *coeff)
 {
   if ( isFirst && isLast )
@@ -327,5 +338,5 @@
   {
     filter<N, true, false, false>(bitDepth, src, srcStride, dst, dstStride, width, height, coeff);
-  }      
+  }
 }
 
@@ -335,6 +346,7 @@
 
 /**
- * \brief Filter a block of luma samples (horizontal)
- *
+ * \brief Filter a block of Luma/Chroma samples (horizontal)
+ *
+ * \param  compID     Chroma component ID
  * \param  src        Pointer to source samples
  * \param  srcStride  Stride of source samples
@@ -345,18 +357,18 @@
  * \param  frac       Fractional sample offset
  * \param  isLast     Flag indicating whether it is the last filtering operation
- */
-Void TComInterpolationFilter::filterHorLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast 
+ * \param  fmt        Chroma format
+ * \param  bitDepth   Bit depth
+ */
+Void TComInterpolationFilter::filterHor(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast, const ChromaFormat fmt, const Int bitDepth 
 #if H_3D_ARP
     , Bool filterType
 #endif
-  )
-{
-  assert(frac >= 0 && frac < 4);
-  
+)
+{
   if ( frac == 0 )
   {
-    filterCopy(g_bitDepthY, src, srcStride, dst, dstStride, width, height, true, isLast );
-  }
-  else
+    filterCopy(bitDepth, src, srcStride, dst, dstStride, width, height, true, isLast );
+  }
+  else if (isLuma(compID))
   {
 #if H_3D_ARP
@@ -368,14 +380,25 @@
     {
 #endif
-    filterHor<NTAPS_LUMA>(g_bitDepthY, src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilter[frac]);
-#if H_3D_ARP
-    }
-#endif
-  }
-}
-
-/**
- * \brief Filter a block of luma samples (vertical)
- *
+
+    assert(frac >= 0 && frac < LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
+    filterHor<NTAPS_LUMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilter[frac]);
+#if H_3D_ARP
+    }
+#endif
+
+  }
+  else
+  {
+    const UInt csx = getComponentScaleX(compID, fmt);
+    assert(frac >=0 && csx<2 && (frac<<(1-csx)) < CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
+    filterHor<NTAPS_CHROMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isLast, m_chromaFilter[frac<<(1-csx)]);
+  }
+}
+
+
+/**
+ * \brief Filter a block of Luma/Chroma samples (vertical)
+ *
+ * \param  compID     Colour component ID
  * \param  src        Pointer to source samples
  * \param  srcStride  Stride of source samples
@@ -387,18 +410,18 @@
  * \param  isFirst    Flag indicating whether it is the first filtering operation
  * \param  isLast     Flag indicating whether it is the last filtering operation
- */
-Void TComInterpolationFilter::filterVerLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast 
+ * \param  fmt        Chroma format
+ * \param  bitDepth   Bit depth
+ */
+Void TComInterpolationFilter::filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth 
 #if H_3D_ARP
     , Bool filterType
 #endif
-  )
-{
-  assert(frac >= 0 && frac < 4);
-  
+)
+{
   if ( frac == 0 )
   {
-    filterCopy(g_bitDepthY, src, srcStride, dst, dstStride, width, height, isFirst, isLast );
-  }
-  else
+    filterCopy(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast );
+  }
+  else if (isLuma(compID))
   {
 #if H_3D_ARP
@@ -410,37 +433,23 @@
     {
 #endif
-    filterVer<NTAPS_LUMA>(g_bitDepthY, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);
-#if H_3D_ARP
-    }
-#endif
-  }
-}
-
-/**
- * \brief Filter a block of chroma samples (horizontal)
- *
- * \param  src        Pointer to source samples
- * \param  srcStride  Stride of source samples
- * \param  dst        Pointer to destination samples
- * \param  dstStride  Stride of destination samples
- * \param  width      Width of block
- * \param  height     Height of block
- * \param  frac       Fractional sample offset
- * \param  isLast     Flag indicating whether it is the last filtering operation
- */
-Void TComInterpolationFilter::filterHorChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast 
+    assert(frac >= 0 && frac < LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
+    filterVer<NTAPS_LUMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);
+#if H_3D_ARP
+    }
+#endif
+
+  }
+  else
+  {
+    const UInt csy = getComponentScaleY(compID, fmt);
+    assert(frac >=0 && csy<2 && (frac<<(1-csy)) < CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS);
+    filterVer<NTAPS_CHROMA>(bitDepth, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac<<(1-csy)]);
+  }
+}
+
 #if H_3D_ARP
     , Bool filterType
 #endif
-  )
-{
-  assert(frac >= 0 && frac < 8);
-  
-  if ( frac == 0 )
-  {
-    filterCopy(g_bitDepthC, src, srcStride, dst, dstStride, width, height, true, isLast );
-  }
-  else
-  {
+
 #if H_3D_ARP
     if(filterType)
@@ -451,38 +460,10 @@
     {
 #endif
-    filterHor<NTAPS_CHROMA>(g_bitDepthC, src, srcStride, dst, dstStride, width, height, isLast, m_chromaFilter[frac]);
-#if H_3D_ARP
-    }
-#endif
-  }
-}
-
-/**
- * \brief Filter a block of chroma samples (vertical)
- *
- * \param  src        Pointer to source samples
- * \param  srcStride  Stride of source samples
- * \param  dst        Pointer to destination samples
- * \param  dstStride  Stride of destination samples
- * \param  width      Width of block
- * \param  height     Height of block
- * \param  frac       Fractional sample offset
- * \param  isFirst    Flag indicating whether it is the first filtering operation
- * \param  isLast     Flag indicating whether it is the last filtering operation
- */
-Void TComInterpolationFilter::filterVerChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast 
+#if H_3D_ARP
+    }
+#endif
 #if H_3D_ARP
     , Bool filterType
 #endif
-  )
-{
-  assert(frac >= 0 && frac < 8);
-  
-  if ( frac == 0 )
-  {
-    filterCopy(g_bitDepthC, src, srcStride, dst, dstStride, width, height, isFirst, isLast );
-  }
-  else
-  {
 #if H_3D_ARP
     if(filterType)
@@ -493,10 +474,9 @@
     {
 #endif
-    filterVer<NTAPS_CHROMA>(g_bitDepthC, src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac]);
-#if H_3D_ARP
-    }
-#endif
-  }
-}
+#if H_3D_ARP
+    }
+#endif
+
+
 
 //! \}
Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComInterpolationFilter.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -37,8 +37,8 @@
  */
 
-#ifndef __HM_TCOMINTERPOLATIONFILTER_H__
-#define __HM_TCOMINTERPOLATIONFILTER_H__
+#ifndef __TCOMINTERPOLATIONFILTER__
+#define __TCOMINTERPOLATIONFILTER__
 
-#include "TypeDef.h"
+#include "CommonDef.h"
 
 //! \ingroup TLibCommon
@@ -61,19 +61,20 @@
 class TComInterpolationFilter
 {
-  static const Short m_lumaFilter[4][NTAPS_LUMA];     ///< Luma filter taps
-  static const Short m_chromaFilter[8][NTAPS_CHROMA]; ///< Chroma filter taps
+  static const TFilterCoeff m_lumaFilter[LUMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_LUMA];     ///< Luma filter taps
+  static const TFilterCoeff m_chromaFilter[CHROMA_INTERPOLATION_FILTER_SUB_SAMPLE_POSITIONS][NTAPS_CHROMA]; ///< Chroma filter taps
 #if H_3D_ARP
   static const Short m_lumaFilterARP  [4][NTAPS_LUMA_ARP];     ///< Luma filter taps for ARP
   static const Short m_chromaFilterARP[8][NTAPS_CHROMA_ARP];   ///< Chroma filter taps for ARP
 #endif
-  static Void filterCopy(Int bitDepth, const Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast);
-  
+
+  static Void filterCopy(Int bitDepth, const Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast);
+
   template<Int N, Bool isVertical, Bool isFirst, Bool isLast>
-  static Void filter(Int bitDepth, Pel const *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Short const *coeff);
+  static Void filter(Int bitDepth, Pel const *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, TFilterCoeff const *coeff);
 
   template<Int N>
-  static Void filterHor(Int bitDepth, Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height,               Bool isLast, Short const *coeff);
+  static Void filterHor(Int bitDepth, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height,               Bool isLast, TFilterCoeff const *coeff);
   template<Int N>
-  static Void filterVer(Int bitDepth, Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast, Short const *coeff);
+  static Void filterVer(Int bitDepth, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Bool isFirst, Bool isLast, TFilterCoeff const *coeff);
 
 public:
@@ -81,25 +82,22 @@
   ~TComInterpolationFilter() {}
 
-  Void filterHorLuma  (Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac,               Bool isLast 
+  Void filterHor(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac,               Bool isLast, const ChromaFormat fmt, const Int bitDepth 
 #if H_3D_ARP
     , Bool filterType = false
 #endif
-    );
-  Void filterVerLuma  (Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast 
+);
+  Void filterVer(const ComponentID compID, Pel *src, Int srcStride, Pel *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast, const ChromaFormat fmt, const Int bitDepth 
 #if H_3D_ARP
     , Bool filterType = false
 #endif
-    );
-  Void filterHorChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac,               Bool isLast 
+);
+};
+
 #if H_3D_ARP
     , Bool filterType = false
 #endif
-    );
-  Void filterVerChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast 
 #if H_3D_ARP
     , Bool filterType = false
 #endif
-    );
-};
 
 //! \}
